/* Generated by G-Wrap: an experimental C->Guile wrapper engine */

#define _GNU_SOURCE
#include <guile/gh.h>
#include <libguile.h>
#include <string.h>
#include <g-wrap-compatibility.h>

#include "gw-report-system.h"
#include <glib.h>
#include <g-wrap-glib.h>
#include <g-wrap-wct.h>
#include <limits.h>
#include <gnc-report.h>
static SCM gw__tmp0_range_minval_gw_int_;
static SCM gw__tmp1_range_maxval_gw_int_;
enum GW__ErrorStatus
{
  GW__ERR_NONE,
  GW__ERR_MISC,
  GW__ERR_MEMORY,
  GW__ERR_RANGE,
  GW__ERR_TYPE,
  GW__ERR_ARGC,
  GW__ERR_ARG_RANGE,
  GW__ERR_ARG_TYPE
};
 
static void
gw__handle_wrapper_error(enum GW__ErrorStatus status,
                         const char *func_name,
                         unsigned int arg_pos,
                         const char *misc_msg,
                         SCM scm_data) __attribute__ ((noreturn));

static void
gw__handle_wrapper_error(enum GW__ErrorStatus status,
                         const char *func_name,
                         unsigned int arg_pos,
                         const char *misc_msg,
                         SCM scm_data)
{
  static SCM out_of_range_key = SCM_BOOL_F;
  static SCM wrong_type_key = SCM_BOOL_F;

  if(SCM_FALSEP(out_of_range_key))
    out_of_range_key = scm_permanent_object(scm_c_make_keyword("out-of-range"));
  if(SCM_FALSEP(wrong_type_key))
    wrong_type_key = scm_permanent_object(scm_c_make_keyword("wrong-type"));

  switch(status) {
  case GW__ERR_NONE:
    scm_misc_error(func_name,
                   "asked to handle error when there wasn't one",
                   SCM_EOL);
    break;
  case GW__ERR_MISC:
    /* scm_data is a list of format args for misc_msg */
    scm_misc_error(func_name, misc_msg, scm_data); break;
  case GW__ERR_MEMORY:
    scm_memory_error(func_name); break;
  case GW__ERR_RANGE:
    scm_error (out_of_range_key,
	       func_name,
	       "Out of range: ~S",
               scm_cons (scm_data, SCM_EOL),
	       SCM_BOOL_F);
    break;
  case GW__ERR_TYPE:
    scm_error(wrong_type_key,
              func_name,
              "Wrong type: ",
              scm_cons (scm_data, SCM_EOL),
              SCM_BOOL_F);
    break;
  case GW__ERR_ARGC:
    scm_wrong_num_args(scm_makfrom0str(func_name)); break;
  case GW__ERR_ARG_RANGE:
    /* scm_data is the bad arg */
    scm_out_of_range(func_name, scm_data); break;
  case GW__ERR_ARG_TYPE:
    /* scm_data is the bad arg */
    scm_wrong_type_arg(func_name, arg_pos, scm_data); break;
  default:
    scm_misc_error(func_name,
                   "asked to handle nonexistent gw:error type: ~S",
                   scm_cons(scm_long2num(status), SCM_EOL));    
    break;
  };
  exit(1);
}
static char * gw__tmp595_gnc_report_find_namestr = "gnc:find-report";
static SCM gw__tmp594_gnc_report_find_wrapper  (SCM gw__scm_arg0 ) {
  SCM gw__scm_result = SCM_UNSPECIFIED;
  enum GW__ErrorStatus gw__error_status = GW__ERR_NONE;
  SCM gw__error_data = SCM_UNSPECIFIED;
  unsigned int gw__arg_pos = 0;
  const char *gw__error_misc_msg = NULL;
SCM gw__c_result;

int gw__c_arg0;
/* ARG 0 */
gw__arg_pos++;
if (gw__error_status != GW__ERR_NONE) goto gw__wrapper_exit;

{
if(SCM_FALSEP(scm_integer_p(gw__scm_arg0))){
   gw__error_status = GW__ERR_ARG_TYPE;
    gw__error_data = gw__scm_arg0;
   goto gw__post_call_arg_0;
}
else if(SCM_FALSEP(scm_geq_p(gw__scm_arg0, gw__tmp0_range_minval_gw_int_))        || SCM_FALSEP(scm_leq_p(gw__scm_arg0, gw__tmp1_range_maxval_gw_int_))){
   gw__error_status = GW__ERR_ARG_TYPE;
    gw__error_data = gw__scm_arg0;
   goto gw__post_call_arg_0;
}
else {gw__c_arg0= gh_scm2long(gw__scm_arg0);
}

if((gw__error_status == GW__ERR_TYPE)){
   gw__error_status = GW__ERR_ARG_TYPE;
    gw__error_data = gw__scm_arg0;
   goto gw__post_call_arg_0;
}
else if((gw__error_status == GW__ERR_RANGE)){
   gw__error_status = GW__ERR_ARG_RANGE;
    gw__error_data = gw__scm_arg0;
   goto gw__post_call_arg_0;
}
if((gw__error_status == GW__ERR_TYPE)){
   gw__error_status = GW__ERR_ARG_TYPE;
    gw__error_data = gw__scm_arg0;
   goto gw__post_call_arg_0;
}
else if((gw__error_status == GW__ERR_RANGE)){
   gw__error_status = GW__ERR_ARG_RANGE;
    gw__error_data = gw__scm_arg0;
   goto gw__post_call_arg_0;
}
if (gw__error_status == GW__ERR_NONE)
{
  /* no pre-call result code requested! */
if (gw__error_status != GW__ERR_NONE) goto gw__post_call_arg_0;
SCM_DEFER_INTS;
gw__c_result = gnc_report_find (gw__c_arg0);
SCM_ALLOW_INTS;
{
gw__scm_result = gw__c_result;
}
}
  gw__post_call_arg_0:
  /* no post-call arg code requested! */
  { /* shut up warnings if no code */ int x = x; }
}
 gw__wrapper_exit:
  if(gw__error_status != GW__ERR_NONE)
    gw__handle_wrapper_error(gw__error_status,
                             gw__tmp595_gnc_report_find_namestr,
                             gw__arg_pos,
                             gw__error_misc_msg,
                             gw__error_data);
  return gw__scm_result;
}
static char * gw__tmp597_gnc_report_add_namestr = "gnc:report-add";
static SCM gw__tmp596_gnc_report_add_wrapper  (SCM gw__scm_arg0 ) {
  SCM gw__scm_result = SCM_UNSPECIFIED;
  enum GW__ErrorStatus gw__error_status = GW__ERR_NONE;
  SCM gw__error_data = SCM_UNSPECIFIED;
  unsigned int gw__arg_pos = 0;
  const char *gw__error_misc_msg = NULL;
int gw__c_result;

SCM gw__c_arg0;
/* ARG 0 */
gw__arg_pos++;
if (gw__error_status != GW__ERR_NONE) goto gw__wrapper_exit;

{
if (!(1)){
   gw__error_status = GW__ERR_ARG_TYPE;
    gw__error_data = gw__scm_arg0;
   goto gw__post_call_arg_0;
}
else {gw__c_arg0 = gw__scm_arg0;
}if ((gw__error_status == GW__ERR_TYPE)){
   gw__error_status = GW__ERR_ARG_TYPE;
    gw__error_data = gw__scm_arg0;
   goto gw__post_call_arg_0;
}
else if ((gw__error_status == GW__ERR_RANGE)){
   gw__error_status = GW__ERR_ARG_RANGE;
    gw__error_data = gw__scm_arg0;
   goto gw__post_call_arg_0;
}
if (gw__error_status == GW__ERR_NONE)
{
  /* no pre-call result code requested! */
if (gw__error_status != GW__ERR_NONE) goto gw__post_call_arg_0;
SCM_DEFER_INTS;
gw__c_result = gnc_report_add (gw__c_arg0);
SCM_ALLOW_INTS;
{
gw__scm_result= gh_long2scm(gw__c_result);
}
}
  gw__post_call_arg_0:
  /* no post-call arg code requested! */
  { /* shut up warnings if no code */ int x = x; }
}
 gw__wrapper_exit:
  if(gw__error_status != GW__ERR_NONE)
    gw__handle_wrapper_error(gw__error_status,
                             gw__tmp597_gnc_report_add_namestr,
                             gw__arg_pos,
                             gw__error_misc_msg,
                             gw__error_data);
  return gw__scm_result;
}
void
gw_init_wrapset_gw_report_system() {
  static int gw_wrapset_initialized = 0;

  if(!gw_wrapset_initialized)
  {
    gh_eval_str("(use-modules (g-wrap runtime))");
    gh_eval_str("(gw:wrapset-register-runtime \"gw-report-system\")");

gh_eval_str("(use-modules (g-wrap gw-glib))");
gh_eval_str("(use-modules (g-wrap gw-wct))");
gh_eval_str("(use-modules (g-wrap gw-standard))");
{
   enum GW__ErrorStatus gw__tmp598_status_var = GW__ERR_NONE;
   SCM gw__tmp600_err_data = SCM_UNSPECIFIED;
   char *gw__tmp599_err_misc_msg = NULL;
   (void) gw__tmp598_status_var;
   (void) gw__tmp600_err_data;
   (void) gw__tmp599_err_misc_msg;
}
{
   enum GW__ErrorStatus gw__tmp601_err_status = GW__ERR_NONE;
   SCM gw__tmp603_err_data = SCM_UNSPECIFIED;
   char *gw__tmp602_err_misc_msg = NULL;
   (void) gw__tmp601_err_status;
   (void) gw__tmp603_err_data;
   (void) gw__tmp602_err_misc_msg;
gw__tmp0_range_minval_gw_int_ = scm_long2num(INT_MIN);
scm_protect_object(gw__tmp0_range_minval_gw_int_);
gw__tmp1_range_maxval_gw_int_ = scm_long2num(INT_MAX);
scm_protect_object(gw__tmp1_range_maxval_gw_int_);
if (gw__tmp601_err_status != GW__ERR_NONE)  gw__handle_wrapper_error (gw__tmp601_err_status,
                            "gw_init_wrapset_gw_report_system",
                            0,
                            gw__tmp602_err_misc_msg,
                            gw__tmp603_err_data);
}
{
   enum GW__ErrorStatus gw__tmp604_status_var = GW__ERR_NONE;
   SCM gw__tmp606_err_data = SCM_UNSPECIFIED;
   char *gw__tmp605_err_misc_msg = NULL;
   (void) gw__tmp604_status_var;
   (void) gw__tmp606_err_data;
   (void) gw__tmp605_err_misc_msg;
    gh_new_procedure(gw__tmp595_gnc_report_find_namestr,
                     (SCM (*) ()) gw__tmp594_gnc_report_find_wrapper,
                     1,
                     0,
                     0);

if (gw__tmp604_status_var != GW__ERR_NONE)  gw__handle_wrapper_error (gw__tmp604_status_var,
                            "gw_init_wrapset_gw_report_system",
                            0,
                            gw__tmp605_err_misc_msg,
                            gw__tmp606_err_data);
    gh_new_procedure(gw__tmp597_gnc_report_add_namestr,
                     (SCM (*) ()) gw__tmp596_gnc_report_add_wrapper,
                     1,
                     0,
                     0);

if (gw__tmp604_status_var != GW__ERR_NONE)  gw__handle_wrapper_error (gw__tmp604_status_var,
                            "gw_init_wrapset_gw_report_system",
                            0,
                            gw__tmp605_err_misc_msg,
                            gw__tmp606_err_data);
}
    gw_wrapset_initialized = 1;
    (void) gw__handle_wrapper_error;
  }
}
